<?php

class actionMypatchFileAjax extends cmsAction {

    public function run($patch_id=false){

        if (!$this->request->isAjax()) { cmsCore::error404(); }

        $is_admin = cmsUser::isAdmin();
        if (!$is_admin) { cmsCore::error404(); }
        if (!$patch_id) { cmsCore::error404(); }

        $grid = $this->loadDataGrid('file');

        $mypatch_model = cmsCore::getModel('mypatch');

        $mypatch_model->setPerPage(admin::perpage);

        $filter     = array();
        $filter_str = $this->request->get('filter', '');

        if ($filter_str){
            parse_str($filter_str, $filter);
            $mypatch_model->applyGridFilter($grid, $filter);
        }

        $total = $mypatch_model->getPatchFilesCount($patch_id);
        $perpage = isset($filter['perpage']) ? $filter['perpage'] : admin::perpage;
        $pages = ceil($total / $perpage);

        $files = $mypatch_model->getPatchFiles($patch_id);

        cmsTemplate::getInstance()->renderGridRowsJSON($grid, $files, $total, $pages);

        $this->halt();

    }

}
