<?php

class modelMypatch extends cmsModel{
    
        // функция для очистки строки от пробелов и табуляции
        public function ChangeSimbolSpace($str){
            $str = str_replace("\t","", $str);
            $str = str_replace(" ","", $str);
        return trim($str);
        }
        
        // функция для очистки строк от кодов перевода и окончания строки
        public function ChangeSimbolNull($str){
            $str = str_replace("\r","", $str);  //возврат каретки
            $str = str_replace("\n","", $str);  //перенос строки
        return $str;
        }
        
        // функция для удаления из массива пустых строк
        public function ClearArrayEmpty($array){
            $ret_arr = array();
            foreach($array as $val){
                $key = $this->ChangeSimbolNull($val);
                if (!empty($key)){
                    $ret_arr[] = $val;
                }
            }
        return $ret_arr;
        }
 
        // функция создания массива с номерами начальных строк для замены
        public function SearchShifts($code_in, $search) {

             // создаем временные массивы данных без пустых строк
            $temp_search = $this->ClearArrayEmpty(explode("\n", $search));
            $temp_in = $this->ClearArrayEmpty($code_in);                    
            
            $search_flag = array();
            foreach($temp_in as $k => $str_in){                               // проверка массива с исходным кодом 
                $str_in_key = $this->ChangeSimbolSpace($str_in);              // создание ОЧИЩЕННОГО от пробелов ключа проверяемой строчки исходного кода, чтобы не изменять код массива
                $str_search_key = $this->ChangeSimbolSpace($temp_search[0]);  // создание ОЧИЩЕННОГО от пробелов ключа ПЕРВОЙ строчки для поиска, чтобы не изменять код массива

                if ($str_in_key == $str_search_key){                            // при совпадении проверяемой и первой искомой строк
                    $slice_in = array_slice($temp_in, $k, sizeof($temp_search));// создаем срез исходных данных от совпавшей строки и длинной равной длине искомого кода
                    $search_flag[$k] = 1;                                       // создаем массив найденных совпадений, где ключ массива равен ключу совпавшей строки в массиве с исходным кодом.
                    foreach ($slice_in as $kk => $str_slice_in){                // проверяем срез исходного кода на 100% совпадение с массивом кода для поиска 
                        if ($this->ChangeSimbolSpace($str_slice_in) != $this->ChangeSimbolSpace($temp_search[$kk])){  // если ОЧИЩЕННЫЕ от пробелов сравниваемы строки , хотябы раз не совпадут
                        $search_flag[$k] = 0;                                                           // "обнуляем данные" в массиве совпадений
                        break;                                                                          // и прекращаем проверку среза
                        }
                    }
                }
            }
            $shifts = array(); // приводим массив совпадений в потребный вид и удаляем строки с ложными срабатываниями.
            foreach ($search_flag as $number => $flags){
                if ($flags == 1){
                $shifts[]= $number;
                }
            }
        return $shifts;
        }    
        
        // функция замены кода
        public function ReplaceCode($code_in,$search,$replace,$shifts,$description) {
            $temp_replace = $this->ClearArrayEmpty(explode("\n", $replace));
            $temp_replace_start = array(
            "\n" . "/*===== ",
            "начало патча -> " . "$description",
            " =====*/" . "\n",
            );
            
            $temp_replace_end = array (
            "\n" . "/*===== ",
            "окончание патча -> " . "$description",
            " =====*/" . "\n\r"                                
            );
                    
            $temp_search = $this->ClearArrayEmpty(explode("\n", $search));
            
            $code_out = $this->ClearArrayEmpty($code_in);
            $replace_start = 0;
            $replace_end = 0;

            foreach ($shifts as $shift_key => $shift){
                    $replace_start = $shift + (sizeof($temp_replace) - sizeof($temp_search)) * $shift_key;
                    $replace_end = $replace_start + sizeof($temp_search);
                    $slice_out_start = array_slice($code_out, 0, $replace_start);
                    $slice_out_end = array_slice($code_out, $replace_end);
                    $code_out = array_merge($slice_out_start, $temp_replace_start, $temp_replace, $temp_replace_end, $slice_out_end);
            }
        return $code_out;
        }
        
        // добавление/редактирование патча в базу
	public function addPatch($patch, $patch_id=false){
                //Вычисляем порядок применения патча
                $this->orderBy('order_patch', 'asc');
                $orders = $this->get('mypatch');
               
                if ($patch ['order_patch'] == NULL) {    
                    if (!empty($orders)){
                        $order_last = array_pop($orders);
                        if (!empty($patch_id) && $order_last['id'] == $patch_id) {
                        $order_last = array_pop($orders);    
                        }
                        $counter = $order_last['order_patch'];
                        $patch ['order_patch'] = ++$counter;
                    }else{
                        $patch ['order_patch'] = "1";
                    }
                }else{
                    if (!empty($orders)){
                        foreach ($orders as $order_check){
                            if (!empty($patch_id) && $order_check['id'] !== $patch_id ){
                                if ($order_check['order_patch'] == $patch ['order_patch']){
                                $mypatch_error['order_patch'] = 1;
                                return ($mypatch_error);
                                }
                            }    
                        }
                    }
                }
            
                if (!empty($patch_id)) {
                    //редактируем данные патча в базе
/*                $state = array_pop($this->get('mypatch', $patch_id));
                if ($state ['state_patch'] != 1){
                    $patch ['state_patch'] = 0; 
                    }else{
                    $patch ['state_patch'] = 1;
                    };
*/
                    return $this->update('mypatch',$patch_id,$patch);            
                } else {

                    //добавляем данные патча в базу
                    $patch ['state_patch'] = 1;
                    return $this->insert('mypatch', $patch);            
                }
	}

        // cмена статуса патча
	public function changeStatePatch($patch_id){
            
            $patch = $this->getItemById('mypatch', $patch_id);
            if ($patch['state_patch'] >= 1) {
                $update_patch['state_patch'] = 0;
                $update_file['state_file'] = 0;
            } else {
                $update_patch['state_patch'] = 1;
                $update_file['state_file'] = 1;
            }
            
            $this->update('mypatch',$patch_id,$update_patch);
            
            $files = $this->getPatchFiles($patch_id);
            foreach ($files as $file) {
            $this->update('mypatch_files',$file['id'],$update_file);
            }
            
            return;    
	}
        
        // вычесление общего количества патчей
        public function getPatchsCount(){

            return $this->getCount('mypatch');

        }
        
        // выборка всех патчей из базы
        public function getPatchs(){

            $patchs = $this->get('mypatch');
            return ($patchs);
        }
        
        // выборка определенного (по ID) патча
        public function getPatch($patch_id){

            return $this->getItemById('mypatch', $patch_id);

        }

        // удаления из базы определенного (по ID) патча и его файлов
        public function deletePatch($patch_id){

            $this->filterEqual('patch_id', $patch_id);
            $patchfiles = $this->get('mypatch_files');
            $this->resetFilters();
                        
            foreach ($patchfiles as $file){
                $this->filterEqual('file_original', $file['file_original']);
                $counter = count($this->get('mypatch_files'));
                $this->resetFilters();
                if ($counter == 1) {
                    $mypatch_error = $this->deleteFileOriginal(array($file));
                    if ($mypatch_error['file_reset']){
                    return ($mypatch_error); 
                    };        
                    
                }
                
                $this->delete('mypatch_files', $file['id']);
            }
            
            return $this->delete('mypatch', $patch_id);

        }
 
        // добавление/редактирование файлов патча в базу
	public function addPatchFile($file, $file_id=false){

            //проверяем есть ли указанный файл
            if (!file_exists($_SERVER['DOCUMENT_ROOT'] . $file['file_original'])) {
                $mypatch_error['file_original'] = 1;
                return($mypatch_error);
            }        
            
            //Вычисляем порядок применения файла патча
                $this->filterEqual('patch_id', $file['patch_id']);
                $this->orderBy('order_file', 'asc');
                $orders = $this->get('mypatch_files');
                $this->resetFilters();
                
                if ($file ['order_file'] == NULL) {    
                    if (!empty($orders)){
                        $order_last = array_pop($orders);
                            if (!empty($file_id) && $order_last['id'] == $file_id) {
                                $order_last = array_pop($orders);    
                            }
                        $counter = $order_last['order_file'];
                        $file ['order_file'] = ++$counter;
                    }else{
                        $file ['order_file'] = "1";
                    }
                }else{
                    if (!empty($orders)){
                        foreach ($orders as $order_check){
                            if (!empty($file_id) && $order_check['id'] !== $file_id ){
                                if ($order_check['order_file'] == $file ['order_file']){
                                    $mypatch_error['order_file'] = 1;
                                    return ($mypatch_error);
                                }
                            }
                        }
                    }
                }
            
           
            //Определяем номер(номера) первых строк заменяемого кода
            if (file_exists($_SERVER['DOCUMENT_ROOT'] . $file['file_original'] . '.original')) {
                $code_in = file($_SERVER['DOCUMENT_ROOT'] . $file['file_original'] . '.original');
            }else{
                $code_in = file($_SERVER['DOCUMENT_ROOT'] . $file['file_original']);
            };
            
            $shifts = $this->SearchShifts($code_in, $file['code_search']);
            
            if (empty($shifts)){
            $mypatch_error['shifts'] = 1;
            return ($mypatch_error);
            };

            if (count($shifts) > 1 ){
            $mypatch_error['shifts'] = 2;
            return ($mypatch_error);
            };
            
            if (!empty($file_id)){
                $file_temp = array_pop($this->get('mypatch_files', $file_id));
                  if ($file_temp ['state_file'] >= 1){
                    $file ['state_file'] = 1; 
                }else{
                    $file ['state_file'] = 0;                     
                };            

            return $this->update('mypatch_files',$file_id,$file);            
                
            } else {
            $file ['state_file'] = 1;
            return $this->insert('mypatch_files', $file);            
            }
	}
        
        // cмена статуса файла патча
        public function changeStatePatchFile($file_id){
            
            $file = $this->getItemById('mypatch_files', $file_id);
            if ($file['state_file'] >= 1) {
                $file['state_file'] = 0;
            } else {
                $file['state_file'] = 1;
            }
                $this->update('mypatch_files',$file_id,$file);
                return $file['patch_id'];
	}
        
        // cмена статуса применения патчей
        public function changeStatePatching($file, $status){
            
            if ($status == "success") {
                $update_file['state_file'] = 2;
            } elseif ($status == "error") {
                $update_file['state_file'] = 3;
            } elseif ($status == "reset") {
                $update_file['state_file'] = 0;
            } else {
                return;
            }

            $this->update('mypatch_files',$file['id'],$update_file);

            $this->filterEqual('patch_id', $file['patch_id']);
            $counter_patch_files_all = $this->getCount('mypatch_files');
            $this->resetFilters();
            
            $this->filterEqual('state_file', '3');
            $this->filterEqual('patch_id', $file['patch_id']);
            $counter_state_error = $this->getCount('mypatch_files');
            $this->resetFilters();
            
            $this->filterEqual('state_file', '2');
            $this->filterEqual('patch_id', $file['patch_id']);
            $counter_state_success = $this->getCount('mypatch_files');
            $this->resetFilters();

            $this->filterEqual('state_file', '0');
            $this->filterEqual('patch_id', $file['patch_id']);
            $counter_state_off = $this->getCount('mypatch_files');
            $this->resetFilters();
            
            if ($counter_patch_files_all == $counter_state_off) {
                $update_patch ['state_patch'] = 0;
                $this->update('mypatch',$file['patch_id'],$update_patch);
            } elseif ($counter_patch_files_all == ($counter_state_success + $counter_state_off)) {
                $update_patch ['state_patch'] = 2;
                $this->update('mypatch',$file['patch_id'],$update_patch);
            } elseif (!empty($counter_state_error)) {
                $update_patch ['state_patch'] = 3;
                $this->update('mypatch',$file['patch_id'],$update_patch);
            }
            return;
	}
        
        // вычесление общего количества файлов патча
        public function getPatchFilesCount($patch_id){
            $this->filterEqual('patch_id', $patch_id);
            return $this->getCount('mypatch_files');
        
        }
        
        // выборка всех файлов определенного(по ID) патча из базы
        public function getPatchFiles($patch_id){
 
            $this->filterEqual('patch_id', $patch_id);
            return $this->get('mypatch_files');
            
        }        

        // выборка всех файлов всех патчей из базы
        public function getAllPatchFiles(){

          $this->join('mypatch', 'p', 'p.id = i.patch_id');
          $this->select('p.order_patch', 'order_patch');
          $this->select('p.state_patch', 'state_patch');
          $this->select('p.description', 'description');
          
          $this->orderBy('order_file', 'asc');
          $this->orderBy('p.order_patch', 'asc');

          return $this->get('mypatch_files');

        }        
        
        // выборка определенного(по ID) файла патча
        public function getPatchFile($file_id){

            return $this->getItemById('mypatch_files', $file_id);

        }

        // удаления из базы определенного(по ID) файла патча
        public function deletePatchFile($file_id){
            
            $file = $this->getPatchFile($file_id);
            $this->filterEqual('file_original', $file['file_original']);
            $counter = count($this->get('mypatch_files'));
            $this->resetFilters();
            if ($counter == 1){
                $mypatch_error = $this->deleteFileOriginal(array($file));
                    if ($mypatch_error['file_reset']){
                    return ($mypatch_error); 
                    };        
                }
            $this->delete('mypatch_files', $file_id);
        }
        
        //создание оригинальных файлов
        public function createFileOriginal($files) {
            $mypatch_options = cmsController::loadOptions('mypatch');

            $connection = @ftp_connect($mypatch_options['host'], $mypatch_options['port']);

            if (!$connection){ $mypatch_error['ftp_auth'] = 1; return $mypatch_error; }
            $session = @ftp_login($connection, $mypatch_options['user'], $mypatch_options['pass']);

            if (!$session){ $mypatch_error['ftp_auth'] = 1; return $mypatch_error; }
            if ($mypatch_options['is_pasv']) { ftp_pasv($connection, true); }

            foreach ($files as $file){
//                if ($file['state_patch'] == 1 && $file['state_file'] == 1 && !file_exists($_SERVER['DOCUMENT_ROOT'] . $file['file_original'] . ".original")){
                if (!file_exists($_SERVER['DOCUMENT_ROOT'] . $file['file_original'] . ".original")){
                    $file_out = $mypatch_options ['path'] . $file['file_original'] . ".original";
                    $file_in = $_SERVER['DOCUMENT_ROOT'] . $file['file_original'];
                    $result = @ftp_put($connection, $file_out, $file_in, FTP_BINARY);
                        if ($result) { @ftp_chmod($connection, 0644, $file_out); }
                        if (!$result) { $error[] = $file['id']; }

                }
            }

            ftp_close($connection);
            $mypatch_error['file_original_create'] = $error;
            return $mypatch_error;

        }

        //удаление оригинальных файлов
        public function deleteFileOriginal($files) {
            $mypatch_options = cmsController::loadOptions('mypatch');

            $connection = @ftp_connect($mypatch_options['host'], $mypatch_options['port']);

            if (!$connection){ $mypatch_error['ftp_auth'] = 1; return $mypatch_error; }
            $session = @ftp_login($connection, $mypatch_options['user'], $mypatch_options['pass']);

            if (!$session){ $mypatch_error['ftp_auth'] = 1; return $mypatch_error; }
            if ($mypatch_options['is_pasv']) { ftp_pasv($connection, true); }

            foreach ($files as $file){

                if (file_exists($_SERVER['DOCUMENT_ROOT'] . $file['file_original'] . ".original")) {
                    $file_reset = $mypatch_options['path'] . $file['file_original'] . ".original";
                    $result = @ftp_delete($connection, $mypatch_options['path'] . $file['file_original']);
                    if ($result) {
                        $result = @ftp_rename($connection, $file_reset, $mypatch_options['path'] . $file['file_original']);
                        if (!$result) { $error[] = $file['file_original']; }
                        if ($result) { @ftp_chmod($connection, 0644, $mypatch_options['path'] . $file['file_original']);}                    
                    }
                }
            }
            ftp_close($connection);
            $mypatch_error['file_reset'] = $error;
            return $mypatch_error;
        }

        //создание измененных файлов
        public function savePatchFiles($files) {
            $mypatch_options = cmsController::loadOptions('mypatch');
            $config = cmsConfig::getInstance();
            $cache_root = $config->cache_root;
            $cache_dir = $_SERVER['DOCUMENT_ROOT'] . $cache_root . "mypatch";
            if (!file_exists($cache_dir)) {
                $result = mkdir($cache_dir, 0777);
                if (!$result) {
                    $mypatch_error['file_patch_create']['cache_dir'] = 1;
                    return $mypatch_error;
                }
            }
            
            $connection = @ftp_connect($mypatch_options['host'], $mypatch_options['port']);

            if (!$connection){ $mypatch_error['ftp_auth'] = 1; return $mypatch_error; }
            $session = @ftp_login($connection, $mypatch_options['user'], $mypatch_options['pass']);

            if (!$session){ $mypatch_error['ftp_auth'] = 1; return $mypatch_error; }
            if ($mypatch_options['is_pasv']) { ftp_pasv($connection, true); }

            foreach ($files as $name => $code){
                if (!file_exists($_SERVER['DOCUMENT_ROOT'] . $name . ".original")){
                    $file['file_original'] = $name;
                    $mypatch_error = $this->createFileOriginal(array($file));
                }
                    $file_out = $mypatch_options ['path'] . $name;
                    $file_path = explode('/', $name);
                    $file_temp = $cache_dir . '/' . array_pop($file_path);

                    //создаем временный патченный файл
                    
                    $result = file_put_contents($file_temp, $code);
                    
                    if ($result){ 
                        $result = @ftp_put($connection, $file_out, $file_temp, FTP_BINARY);
                            if ($result) { 
                                // устанавливаем права
                                @ftp_chmod($connection, 0644, $file_out); 
                                // подчищаем за собой
                                unlink($file_temp);
                            }
                            if (!$result) { $error['create'][] = $name; }
                   } else {
                       $error['temp'][] = $name;
                   }    
            }

            ftp_close($connection);
            $mypatch_error['file_patch_create'] = $error;
            return $mypatch_error;
        }
      
}

